import { Action } from '@ngrx/store';

import { RPCError } from 'packages/core/rpc/error';


import { MetaCrawler } from '../../model';

export enum ActionType {
  ReadAll = '[meta.crawler-readall] ReadAll',
  ReadAllSuccess = '[meta.crawler-readall] ReadAllSuccess',
  ReadAllFailure = '[meta.crawler-readall] ReadAllFailure',
}

export class ReadAll implements Action {
  readonly type = ActionType.ReadAll;

  constructor(public payload: {}) {}
}

export class ReadAllSuccess implements Action {
  readonly type = ActionType.ReadAllSuccess;

  constructor(public payload: MetaCrawler[]) {}
}

export class ReadAllFailure implements Action {
  readonly type = ActionType.ReadAllFailure;

  constructor(public payload: RPCError) {}
}

export type Actions =
  | ReadAll
  | ReadAllSuccess
  | ReadAllFailure

;
