import { Component, OnInit, AfterViewInit, ViewChild } from '@angular/core';
import { MatTableDataSource, MatSort } from '@angular/material';
import { AfterContentInit } from '@angular/core/src/metadata/lifecycle_hooks';
import { Router } from '@angular/router';
import { Sensor } from '../../model';


@Component({
  selector: 'of-sensor-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.scss']
})
export class ListComponent implements OnInit, AfterContentInit {

  displayedColumns = ['crawler', 'type', 'name', 'sensors'];
  dataSource: MatTableDataSource<Sensor>;
  @ViewChild(MatSort) sort: MatSort;

  /**
   * Set the sort after the view init since this component will
   * be able to query its view for the initialized sort.
   */
  ngAfterContentInit() {
    // temporary data
    const data: Sensor[] = new Array();
    for (let i = 0; i < 3; i++) {
      const t: Sensor = {
        id: i,
        target: {
          id: 1,
          displayName: '192.168.1.1',
        },
        crawler: {
          id: 1,
          name: 'WMI'
        },
      };
      data.push(t);
    }

    this.dataSource = new MatTableDataSource(data);
    this.dataSource.sort = this.sort;
  }

  constructor(private router: Router) { }

  ngOnInit() {
  }

  handleRowClick(obj: Sensor) {
    this.router.navigate(['target', obj.id]);
  }
}
